#!/usr/local/bin/perl
#
# transcription ȯ񡤵N-gramperlץ
#
# Ȥ: mk_seqmodel [options] transcriptե ϥե̾
# options:
#  [-g Х뼭]    Х뼭ꤹ
#  [-startsil HMM̾]      ̵֤βǥ̾ (default: silB)
#  [-endsil HMM̾]        λ̵֤βǥ̾ (default: silE)
# 
# Ϥϡֽϥե̾.dictסֽϥե̾.2gram
# ֽϥե̾.3gram.revפȤʤ
#

# default
$start_sil = "silB";
$end_sil = "silE";

############################################################
require "jcode.pl";

if (! @ARGV) {
    &usage;
    exit;
}
$gdicfile = "";
$transfile = "";
$outfile = "";
while (@ARGV) {
    $arg = shift;
    if ($arg eq "-g") {
	if (! @ARGV) {
	    &usage;
	    exit;
	}
	$gdicfile = shift;
    } elsif ($arg eq "-startsil") {
	if (! @ARGV) {
	    &usage;
	    exit;
	}
	$start_sil = shift;
    } elsif ($arg eq "-endsil") {
	if (! @ARGV) {
	    &usage;
	    exit;
	}
	$end_sil = shift;
    } else {
	if ($transfile eq "") {
	    $transfile = $arg;
	} else {
	    $outfile = $arg;
	}
    }
}
if ($transfile eq "" || $outfile eq "") {
    &usage;
    exit;
}
$outdict = $outfile . ".dict";
$out2gram = $outfile . ".2gram";
$out3gram = $outfile . ".3gram.rev";

if ($gdicfile ne "") {
    print STDERR "Reading global dictionary...";
    open(GDICT, $gdicfile) || die "cannot open global dictionary \"$gdicfile\"\n";
    $gnum = 0;
    while(<GDICT>) {
	chop;
	if (/^(\S+)\s\[(\S*)\]\s(.+)$/) {
	    $wname[$gnum] = $1;
	    $woutput[$gnum] = $2;
	    $phones[$gnum] = $3;
	    $gnum++;
	} else {
	    die "global dictionary: wrong format\n";
	}
    }
    close(GDICT);
    print STDERR "done ($gnum words)\n";
}

open(TRANS, $transfile) || die "cannot open transcription file \"$transfile\"\n";
$wnum = 0;
while(<TRANS>) {
    chop;
    $word[$wnum] = $_;
    $wnum++;
}
close(TRANS);
print STDERR "\"$transfile\" has $wnum words\n";
print STDERR "---\n";

# generate dict
if ($gdicfile ne "") {
    # extract global dict
    print STDERR "generating $outdict using global dict...";
    open(DICT, ">$outdict") || die "cannot open \"$outdict\" for output\n";
    @dicout = ();
    push(@dicout, "<s> [$start_sil] $start_sil\n");
    push(@dicout, "</s> [$end_sil] $end_sil\n");
    $out_wnum = 2;
    for($i=0;$i<$wnum;$i++) {
	$wd = $word[$i];
	$wdstr = sprintf("%s%d", $wd, $i);
	$found = 0;
	for ($w=0;$w<$gnum;$w++) {
	    if ($woutput[$w] eq $wd || $wname[$w] eq $wd) {
		push(@dicout, "$wdstr [$wd] $phones[$w]\n");
		$out_wnum++;
		$found++;
	    }
	}
	if ($found == 0) {
	    print STDERR "Error: pronunciation of \"$wd\" not found in global dict\n";
	}
    }
    sort(@dicout);
    $oldt = "";
    while(@dicout) {
	$t = shift(@dicout);
	if ($t ne $oldt) {
	    print DICT "$t";
	}
	$oldt = $t;
    }
    close(DICT);
    print STDERR "done ($out_wnum entries)\n";
} else {
    # convert {hira,kata}kana to phones
    print STDERR "converting to $outdict...";
    open(DICT, ">$outdict") || die "cannot open \"$outdict\" for output\n";
    print DICT "<s> [$start_sil] $start_sil\n";
    print DICT "</s> [$end_sil] $end_sil\n";
    $out_wnum = 2;
    for($i=0;$i<$wnum;$i++) {
	$wd = $word[$i];
	$wdstr = sprintf("%s%d", $wd, $i);
	$ph = &hirakata2phones($wd);
	print DICT "$wdstr [$wd] $ph\n";
	$out_wnum++;
    }
    close(DICT);
    print STDERR "done ($out_wnum entries)\n";
}	
    
# generate 2-gram
print STDERR "generating $out2gram...";
open(GRAM, ">$out2gram") || die "cannot open \"$out2gram\" for output\n";
print GRAM "\\data\\\n";
printf(GRAM "ngram 1=%d\n",$wnum+2);
printf(GRAM "ngram 2=%d\n",$wnum+1);
print GRAM "\n\\1-grams:\n";
print GRAM "0.0 <s> -99.0\n";
print GRAM "0.0 </s> -99.0\n";
for($i=0;$i<$wnum;$i++) {
    $wdstr = sprintf("%s%d", $word[$i], $i);
    print GRAM "0.0 $wdstr -99.0\n";
}
print GRAM "\n\\2-grams:\n";
for($i=0;$i<$wnum;$i++) {
    $wdstr = sprintf("%s%d", $word[$i], $i);
    if ($i == 0) {
	print GRAM "0.0 <s> $wdstr\n";
    }
    if ($i == $wnum - 1) {
	$wdstr2 = "</s>";
    } else {
	$wdstr2 = sprintf("%s%d", $word[$i+1], $i+1);
    }
    print GRAM "0.0 $wdstr $wdstr2\n";
}
print GRAM "\n\\end\\\n";
close(GRAM);
print STDERR "done\n";

# generate 3-gram
print STDERR "generating $out3gram...";
open(GRAM, ">$out3gram") || die "cannot open \"$out3gram\" for output\n";
print GRAM "\\data\\\n";
printf(GRAM "ngram 1=%d\n",$wnum+2);
printf(GRAM "ngram 2=%d\n",$wnum+1);
printf(GRAM "ngram 3=%d\n",$wnum);
print GRAM "\n\\1-grams:\n";
print GRAM "0.0 <s> -99.0\n";
print GRAM "0.0 </s> -99.0\n";
for($i=0;$i<$wnum;$i++) {
    $wdstr = sprintf("%s%d", $word[$i], $i);
    print GRAM "0.0 $wdstr -99.0\n";
}
print GRAM "\n\\2-grams:\n";
for($i=$wnum-1;$i>=0;$i--) {
    $wdstr = sprintf("%s%d", $word[$i], $i);
    if ($i == $wnum-1) {
	print GRAM "0.0 </s> $wdstr -99.0\n";
    }
    if ($i == 0) {
	$wdstr2 = "<s>";
    } else {
	$wdstr2 = sprintf("%s%d", $word[$i-1], $i-1);
    }
    print GRAM "0.0 $wdstr $wdstr2 -99.0\n";
}
print GRAM "\n\\3-grams:\n";
for($i=$wnum-1;$i>=0;$i--) {
    $ss = "";
    if ($i == $wnum-1) {
	$ss .= " </s>";
    } else  {
	$ss .= sprintf(" %s%d", $word[$i+1], $i+1);
    }
    $ss .= sprintf( " %s%d", $word[$i], $i);
    if ($i == 0) {
	$ss .= " <s>";
    } else  {
	$ss .= sprintf( " %s%d", $word[$i-1], $i-1);
    }
    print GRAM "0.0$ss\n";
}
print GRAM "\n\\end\\\n";
close(GRAM);
print STDERR "done\n";

sub usage {
    print STDERR "usage: $0 [-g globaldictfile] [-startsil HMMname] [-endsil HMMname] transcriptfile\n";
}


sub hirakata2phones {
    $s = pop(@_);
    # ʢҤ餬Ѵjcode.plѡ
    &jcode::tr(\$s, '-', '-');
    
# Ҥ餬ʡĹʳϤΤޤ
# 2ʸʤѴ§
    $s =~ s/Ǥ/ d i/g;
    $s =~ s/Ƥ/ t i/g;
    $s =~ s// s i/g;
    $s =~ s// z i/g;
    $s =~ s// ky a/g;
    $s =~ s// ky u/g;
    $s =~ s// ky o/g;
    $s =~ s// sh a/g;
    $s =~ s// sh u/g;
    $s =~ s// sh e/g;
    $s =~ s// sh o/g;
    $s =~ s// ch a/g;
    $s =~ s// ch u/g;
    $s =~ s// ch e/g;
    $s =~ s// ch o/g;
    $s =~ s/ˤ/ ny a/g;
    $s =~ s/ˤ/ ny u/g;
    $s =~ s/ˤ/ ny o/g;
    $s =~ s/Ҥ/ hy a/g;
    $s =~ s/Ҥ/ hy u/g;
    $s =~ s/Ҥ/ hy o/g;
    $s =~ s/ߤ/ my a/g;
    $s =~ s/ߤ/ my u/g;
    $s =~ s/ߤ/ my o/g;
    $s =~ s// ry a/g;
    $s =~ s// ry u/g;
    $s =~ s// ry o/g;
    $s =~ s// gy a/g;
    $s =~ s// gy u/g;
    $s =~ s// gy o/g;
    $s =~ s// j a/g;
    $s =~ s// j u/g;
    $s =~ s// j e/g;
    $s =~ s// j o/g;
    $s =~ s/Ӥ/ by a/g;
    $s =~ s/Ӥ/ by u/g;
    $s =~ s/Ӥ/ by o/g;
    $s =~ s/Ԥ/ py a/g;
    $s =~ s/Ԥ/ py u/g;
    $s =~ s/Ԥ/ py o/g;
    $s =~ s// w i/g;
    $s =~ s// w e/g;
    $s =~ s// w o/g;
    $s =~ s/դ/ f a/g;
    $s =~ s/դ/ f i/g;
    $s =~ s/դ/ f e/g;
    $s =~ s/դ/ f o/g;

# 1ʤѴ§
    $s =~ s// a/g;
    $s =~ s// i/g;
    $s =~ s// u/g;
    $s =~ s// e/g;
    $s =~ s// o/g;
    $s =~ s// k a/g;
    $s =~ s// k i/g;
    $s =~ s// k u/g;
    $s =~ s// k e/g;
    $s =~ s// k o/g;
    $s =~ s// s a/g;
    $s =~ s// sh i/g;
    $s =~ s// s u/g;
    $s =~ s// s e/g;
    $s =~ s// s o/g;
    $s =~ s// t a/g;
    $s =~ s// ch i/g;
    $s =~ s// ts u/g;
    $s =~ s// t e/g;
    $s =~ s// t o/g;
    $s =~ s// n a/g;
    $s =~ s// n i/g;
    $s =~ s// n u/g;
    $s =~ s// n e/g;
    $s =~ s// n o/g;
    $s =~ s// h a/g;
    $s =~ s// h i/g;
    $s =~ s// f u/g;
    $s =~ s// h e/g;
    $s =~ s// h o/g;
    $s =~ s// m a/g;
    $s =~ s// m i/g;
    $s =~ s// m u/g;
    $s =~ s// m e/g;
    $s =~ s// m o/g;
    $s =~ s// r a/g;
    $s =~ s// r i/g;
    $s =~ s// r u/g;
    $s =~ s// r e/g;
    $s =~ s// r o/g;
    $s =~ s// g a/g;
    $s =~ s// g i/g;
    $s =~ s// g u/g;
    $s =~ s// g e/g;
    $s =~ s// g o/g;
    $s =~ s// z a/g;
    $s =~ s// j i/g;
    $s =~ s// z u/g;
    $s =~ s// z e/g;
    $s =~ s// z o/g;
    $s =~ s// d a/g;
    $s =~ s// j i/g;
    $s =~ s// z u/g;
    $s =~ s// d e/g;
    $s =~ s// d o/g;
    $s =~ s// b a/g;
    $s =~ s// b i/g;
    $s =~ s// b u/g;
    $s =~ s// b e/g;
    $s =~ s// b o/g;
    $s =~ s// p a/g;
    $s =~ s// p i/g;
    $s =~ s// p u/g;
    $s =~ s// p e/g;
    $s =~ s// p o/g;
    $s =~ s// y a/g;
    $s =~ s// y u/g;
    $s =~ s// y o/g;
    $s =~ s// w a/g;
    $s =~ s// N/g;
    $s =~ s// q/g;
    $s =~ s//:/g;

#¾̤ʥ롼
    $s =~ s// o/g;

    $s =~ s/^ ([a-z])/$1/g;
    return $s;
}
